<template>
	<a-drawer :width="500" title="搜索" placement="right" :open="openSearchModel" @close="onClose">
		<template #extra>
		  <a-button style="margin-right: 8px" @click="clearSearch">清空搜索</a-button>
		  <a-button type="primary" @click="getData">搜索</a-button>
		</template>
		<a-form :model="commomParams.search">
			<a-row :gutter="[10]">
				<a-col span="24">
					<a-form-item>
						<a-input addon-before="地址" v-model:value="commomParams.search.keyword"
							placeholder="请输入地址"  @keyup.enter="getData"/>
					</a-form-item>
				</a-col>
				<a-col span="24">
					<a-form-item>
						<search-select placeholder="请搜索选择地址分类" :list="cate_list" :select_value="commomParams.search.cate"
							@searchData="cateSearch" @getSelectValue="getCateValue"></search-select>
					</a-form-item>
				</a-col>
			</a-row>
		</a-form>
	</a-drawer>
</template>

<script lang="ts" setup>
	import { ref, onMounted, watch, computed } from 'vue';
	import { GetActivityaddressCate} from '@/apis/models';
	
	import { useCommon } from '@/hooks/useCommon';
	let { store, commomParams, openSearchModel, hideSearch } = useCommon();
	let props = defineProps(['search_params']);
	const emit = defineEmits();

	openSearchModel = computed(() => {
		return store.state.openSearchModel;
	})
	
	onMounted(() => {
		cateSearch()
	})


	interface listType {
		cate : String
	}

	commomParams.value.search = commomParams.value.search as listType;
	commomParams.value.search.cate = null;
	// watch(() => props.search_params, (newVal) => {
	// 	emit('searchData', commomParams.value.search)
	// })

	const getData = () => {
		emit('searchData', commomParams.value.search);
		hideSearch()
	}

	// 清空搜索
	const clearSearch = () => {
		commomParams.value.search = {
			page: 1,
			pagesize: 10,
			sort: 'id',
			sortby: 'desc',
			keyword: ''
		}
		emit('clearData', commomParams.value.search);
		hideSearch()
	}

	const onClose = () => {
		clearSearch()
		hideSearch()
	}
	
	let cate_list = ref<Object[]>([])
	const cateSearch = (val : Object) => {
		GetActivityaddressCate(val).then((res : object) => {
			const data = res.data.activity_address_cate.map((item : object) => ({
				label: item,
				value: item,
			}));
			cate_list.value = data;
		})
	}
	const getCateValue = (val : Object) => {
		commomParams.value.search.cate = val.key;
		getData()
	}
</script>

<style>
</style>